<template>
  <transition 
    mode="out-in"
    @before-enter="beforeEnter"
    @enter="enter"
    :css="false">
    <div class="menudrawer" v-if="menuOpened">
      <nuxt-link exact to="/">{{ selectedUser.name | firstName}}'s Home</nuxt-link><br />
      <nuxt-link to="/place">{{ selectedUser.name | firstName}}'s Places</nuxt-link><br />
      <nuxt-link to="/group">{{ selectedUser.name | firstName}}'s Group Trips</nuxt-link>
    </div>
  </transition>
</template>

<script>
import { mapGetters } from 'vuex';
import { TweenMax, TimelineMax, Sine, Expo } from 'gsap';

export default {
  props: {
    menuOpened: {
      type: Boolean,
      default: false,
    },
  },
  methods: {
    beforeEnter(el) {
      TweenMax.set(el, {
        opacity: 0,
        scale: 0,
        transformOrigin: '100% 0%',
      });
      TweenMax.set(el.childNodes, {
        opacity: 0,
      });
    },
    enter(el, done) {
      TweenMax.fromTo(
        el,
        0.2,
        {
          opacity: 0,
          scale: 0,
        },
        {
          opacity: 1,
          scale: 1,
          ease: Sine.easeOut,
        },
      );
      TweenMax.staggerFromTo(
        el.childNodes,
        0.45,
        {
          opacity: 0,
        },
        {
          delay: 0.1,
          opacity: 1,
          ease: Sine.easeOut,
        },
        0.04,
      );
      done();
    },
  },
  computed: {
    ...mapGetters(['selectedUser']),
  },
  filters: {
    firstName(input) {
      const lastIndex = input.lastIndexOf(' ');
      return input.substring(0, lastIndex);
    },
  },
}
</script>

<style scoped>
.menudrawer {
  background: rgba(0, 0, 0, 0.8);
  line-height: 1.8;
  text-align: right;
  position: absolute;
  right: 0;
  top: 45px;
  padding: 20px;
  border-radius: 4px;
  z-index: 10000;
}

a,
a:visited,
a:active {
  color: white;
}
</style>